#!/usr/bin/perl
# Written by Gary W. Houle gary@avalanche.dyndns.com, and is Public Domain
#This is a perl CGI script to allow users to create email aliases
#from a web page put up by the system administrator.  The alias file
#in /etc must be writable by the nobody account or whatever the ownership
#the web daemon runs as.  Provided with this script is a sample web page to 
#be used for creating the aliases.  The format of the page is not important,
#as long as the form input names are the same as in the sample.

{
print "Content-type:text/html\n\n";

#Process the form to a readable manner

       read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
       @pairs = split(/&/, $buffer);
       foreach $pair (@pairs)
{
           ($name, $value) = split(/=/, $pair);
           $value =~ tr/+/ /;
           $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
           $value =~ s/~!/ ~!/g;
           $FORM{$name} = $value;
}

#the variables nuname and nalias are the names of the inputs in the
#html form that will use this script.
#this section makes sure that they filled out all of the fields

	if ($FORM{'nuname'} eq "" || $FORM{'nalias'} eq "") {
		#these lines below can be changed to customize your error page
		print "<body bgcolor\=\"white\">";
		print "<img src=\"/images/logolong.gif\">";
		print "<h2>Error</h2>";	
		print "You must fill out all of the fields!";
		print "<br>";
		print "<a href=\"/alias.shtml\" target=\"main\">Try Again</a>";
		die;
}
							
#This section makes sure that the alias doesn't already exist and if so,
#gives an error message to the user.

	open(READFILE, "/etc/aliases");		#open the alias file read only
       foreach $i (<READFILE>) {
		chop($i);
	($alias, $uname) = split(/\:/,$i);
		if ($FORM{'nalias'} eq $alias) {
		#these lines below can be changed to customize your error page
		print "<body bgcolor\=\"white\">";
		print "<img src=\"/images/logolong.gif\">";
		print "<h2>Error</h2>";	
		print "This alias has already been chosen by another user!";
		print "<br>";
		print "<a href=\"/alias.shtml\" target=\"main\">Try Again</a>";
		close(READFILE);
		die;
}	}

#This is new as of v-1.0.1, it adds the ability to verify usernames.  Now
#you won't get people creating bad aliases to nonexistant accounts.  This
#might be a security risk if you don't have shadow passwords installed.
	open(USERS, "/etc/passwd");	#open the paswd file read only
	foreach $line (<USERS>)  {
		chop($line);
	($acc) = split(/\:/,$line);
		if  ($FORM{'nuname'} eq $acc) {
		close(USERS);

#This section adds the new alias to the alias file.  After this is finished 
#the alias is not ready however.  The system admin must run the newaliases
#program to update the database.  A job for CRON possibly!
#Below this line is an example crontab entry for running the newaliases program
#0 8 * * * /sbin/newaliases
# This runs the newlaiases program everyday at 08:00 
#newaliases may not be in sbin on your system so double check. 
	
	open(WRITEFILE, ">>/etc/aliases");
	print WRITEFILE "$FORM{'nalias'}\:$FORM{'nuname'}\n";
	close(WRITEFILE);	


#This section creates the html page to tell the user that the alias was
#created successfully.  You can change these lines to customize it for your own
#purposes.

       print "<html>";
	print	"<body bgcolor=\"white\">";
	print "<img src=\"http://avalanche.dyndns.com/images/logolong.gif\"><br>";
       print "<h2>Congratulations</h2>";
       print "Your new alias has been added to the database and will be updated at 08:00 CDT tomorrow morning.  You will be able to receive email with your new alias at that time.<br>";
	print "Return to the <a href=\"http://avalanche.dyndns.com/home.shtml/\" target=\"main\">Main Page</a><p>";
	print "<hr>";
	print "<center>";
	print "Last Modified:  Friday, 26-Aug-97 18:22:22 CDT<br>";
	print "Maintained by:  <a href=\"mailto:gary\@avalanche.dyndns.com\">Gary W. Houle</a>";
	print "</body></html>";
	die;
}}

		#these lines below can be changed to customize your error page
		print "<body bgcolor\=\"white\">";
		print "<img src=\"/images/logolong.gif\">";
		print "<h2>Error</h2>";
		print "You must have an account on avalanche for this to work!";
		print "<br>";
		print "<a href=\"/alias.shtml\" target=\"main\">Try Again</a>";
		die;
}


